Index: res_agi.c
===================================================================
--- res_agi.c	(revision 134311)
+++ res_agi.c	(working copy)
@@ -1841,6 +1841,7 @@
 	/* how many times we'll retry if ast_waitfor_nandfs will return without either 
 	  channel or file descriptor in case select is interrupted by a system call (EINTR) */
 	int retry = AGI_NANDFS_RETRY;
+	struct timeval start;
 
 	if (!(readf = fdopen(agi->ctrl, "r"))) {
 		ast_log(LOG_WARNING, "Unable to fdopen file descriptor\n");
@@ -1940,7 +1941,14 @@
 				usleep(1);
 			}
 		}
-		waitpid(pid, status, WNOHANG);
+
+		/* waiting for child to exit no more than 500ms */
+		start = ast_tvnow();
+		while(waitpid(pid, status, WNOHANG)==0) {
+		   if (ast_tvdiff_ms(ast_tvnow(),start)>=500) 
+		   		break;
+		   usleep(10);
+		}
 	}
 	fclose(readf);
 	return returnstatus;
